<?php
// Version: 1.3; PortalAdminHeader

function template_header_edit()
{
	global $context, $settings, $scripturl, $txt, $helptxt;

	echo '
	<div id="sp_edit_header">
		<form action="', $scripturl, '?action=admin;area=portalheader;sa=edit" method="post" accept-charset="', $context['character_set'], '" onsubmit="submitonce(this);">
			<div class="cat_bar">
				<h3 class="catbg">
					', $txt['sp_admin_header_general'], '
				</h3>
			</div>
			<div class="information">
				<span class="topslice"><span></span></span>
				<div class="sp_content_padding">
					<dl class="sp_form">
						<dt>
							<label for="page_type">', $txt['sp_admin_pages_col_type'], ':</label>
						</dt>
						<dd>
							<select name="type" id="page_type" onchange="sp_update_editor();">';

	echo '
								<option value="html" selected>', $txt['sp_pages_type_html'], '</option>';

	echo '
							</select>
						</dd>
						<dt>
							<label for="header_status">', $txt['sp_admin_pages_col_status'], ':</label>
						</dt>
						<dd>
							<input type="checkbox" name="status" id="header_status" value="1"', $context['SPortal']['header']['status'] ? ' checked="checked"' : '', ' class="input_check" />
						</dd>
						<dt>
							<a href="' . $scripturl . '?action=helpadmin;help=sp_HeaderCode" onclick="return reqWin(this.href);" class="help"><img src="' . $settings['theme_url'] . '/images/helptopics.png" alt="[Help] " class="icon"></a>
							', $txt['sp_admin_header_body'], ':
						</dt>
						<dd>
						</dd>
					</dl>
					<div id="sp_rich_editor">
						<div>' . (empty($context['SPortal']['header']['body']) ? '
							<textarea style="height: 200px;width: 95%;" name="content" placeholder="' . $txt['sp_admin_header_placeholder'] . '"></textarea>' : '
							<textarea style="height: 200px;width: 95%;" name="content" placeholder="' . $txt['sp_admin_header_placeholder'] . '">' . $context['SPortal']['header']['body'] . '</textarea>') . '
						</div>
					</div>
					<dl class="sp_form">
						<dt>
							<a href="' . $scripturl . '?action=helpadmin;help=sp_HeaderIgnores" onclick="return reqWin(this.href);" class="help"><img src="' . $settings['theme_url'] . '/images/helptopics.png" alt="[Help] " class="icon"></a>
							', $txt['sp_admin_header_ignores'], ':
						</dt>
						<dd>
						</dd>
					</dl>
					<div id="sp_rich_editor">
						<div>' . (empty($context['SPortal']['header']['ignores']) ? '
							<textarea style="height: 50px;width: 95%;" name="ignores" placeholder="' . $txt['sp_admin_header_ignores_placeholder'] . '"></textarea>' : '
							<textarea style="height: 50px;width: 95%;" name="ignores" placeholder="' . $txt['sp_admin_header_ignores_placeholder'] . '">' . $context['SPortal']['header']['ignores'] . '</textarea>') . '
						</div>
					</div>
					<div class="sp_button_container">
						<input type="submit" name="submit" value="', $context['header_title'], '" class="button_submit" />
					</div>
				</div>
				<span class="botslice"><span></span></span>
			</div>
			<input type="hidden" name="page_id" value="1" />
			<input type="hidden" name="', $context['session_var'], '" value="', $context['session_id'], '" />
		</form>
	</div>';
}

?>