<?php
// Version: 1.3; Portal

function template_portal_above()
{
	global $context, $modSettings;

	if (empty($_SESSION['isPortalMobile']) && empty($modSettings['sp_disable_side_collapse']) && ($context['SPortal']['sides'][1]['active'] || $context['SPortal']['sides'][4]['active']))
	{
		echo '
	<div class="sp_right sp_fullwidth">';

		if ($context['SPortal']['sides'][1]['active'])
			echo '
		<a href="#side" onclick="return sp_collapseSide(1)">', sp_embed_image($context['SPortal']['sides'][1]['collapsed'] ? 'expand' : 'collapse', '', null, null, true, 'sp_collapse_side1'), '</a>';

		if ($context['SPortal']['sides'][4]['active'])
			echo '
		<a href="#side" onclick="return sp_collapseSide(4)">', sp_embed_image($context['SPortal']['sides'][4]['collapsed'] ? 'expand' : 'collapse', '', null, null, true, 'sp_collapse_side4'), '</a>';

		echo '
	</div>';
	}

	if (!empty($context['SPortal']['blocks'][5]))
	{

		if (empty($_SESSION['isPortalMobile']))
		{
			echo '
	<div id="sp_header">';
			foreach ($context['SPortal']['blocks'][5] as $block)
				template_block($block);
			echo '
	</div>';
		}
		else
		{
			echo '
	<div class="ehPortal_table" id="sp_header" style="padding: 0em;margin: 0em auto;position: relative;">';
			foreach ($context['SPortal']['blocks'][5] as $block)
			{
				echo '
		<div class="ehPortal_row">
			<div class="ehPortal_cell" style="min-width: 100vw;">';
				template_block($block);
				echo '
			</div>
		</div';
			}
			echo '

	</div>';
		}
	}

	echo '
	<div class="ehPortal_table" id="sp_main">
		<div class="ehPortal_row">';

	if (!empty($modSettings['showleft']) && !empty($context['SPortal']['blocks'][1]))
	{
		$units = !empty($modSettings['leftwidth']) && strpos($modSettings['leftwidth'], 'px') === false && strpos($modSettings['leftwidth'], '%') === false ? 'px' : '';
		if (empty($_SESSION['isPortalMobile']))
		{
			echo '
			<div class="ehPortal_cell" id="sp_left"', $context['SPortal']['sides'][1]['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : (!empty($modSettings['leftwidth']) ? ' style="width: ' . $modSettings['leftwidth'] . $units . ';"' : ''), '>';

			foreach ($context['SPortal']['blocks'][1] as $block)
				template_block($block);

			echo '
			</div>';
		}
		else
		{
			foreach ($context['SPortal']['blocks'][1] as $block)
			{
				echo '
			<div class="ehPortal_cell"', $context['SPortal']['sides'][1]['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : ' style="padding: 0em;margin: 0em auto;position: relative;min-width: 100vw;width: 100vw;"', '>';
				template_block($block);
				echo '
			</div>
		</div>
		<div class="ehPortal_row">';
			}
		}
	}

	if (!empty($context['SPortal']['blocks'][2]))
	{
		if (empty($_SESSION['isPortalMobile']))
		{
			echo '
			<div class="ehPortal_cell" id="sp_center"', (empty($_SESSION['isPortalMobile']) ? '' : ' style="max-width: 100vw;min-width: 98vw;"'), '>';

			foreach ($context['SPortal']['blocks'][2] as $block)
				template_block($block);
		}
		else
		{
			foreach ($context['SPortal']['blocks'][2] as $block)
			{
				echo '
			<div class="ehPortal_cell" id="sp_center" style="max-width: 100vw;min-width: 98vw;padding: 0em;margin: 0em auto;position: relative;">';
				template_block($block);
				echo '
			</div>
		</div>
		<div class="ehPortal_row">';
			}

			echo '
			<div class="ehPortal_cell" id="sp_center" style="max-width: 100vw;min-width: 98vw;', (!empty($context['SPortal']['blocks'][3]) ? 'padding: 0em;margin: 0em auto;position: relative;' : ''), '">';
		}

		if (empty($context['SPortal']['on_portal']))
			echo '
					<br class="sp_side_clear" />';
	}
	elseif (empty($_SESSION['isPortalMobile']))
		echo '
			<div class="ehPortal_cell" id="sp_center"', (!empty($context['SPortal']['blocks'][3]) ? ' style="padding: 0em;margin: 0em auto;position: relative;"' : ''), '>';
	else
		echo '
			<div class="ehPortal_cell" id="sp_center" style="max-width: 100vw;min-width: 98vw;', (!empty($context['SPortal']['blocks'][3]) ? 'padding: 0em;margin: 0em auto;position: relative;' : ''), '">';
}

function template_portal_below()
{
	global $context, $modSettings;

	if (!empty($context['SPortal']['blocks'][3]))
	{
		if (empty($context['SPortal']['on_portal']) || !empty($context['SPortal']['blocks'][2]) || !empty($modSettings['articleactive']))
			echo '
					<br class="sp_side_clear" />';

		if (empty($_SESSION['isPortalMobile']))
		{
			foreach ($context['SPortal']['blocks'][3] as $block)
				template_block($block);
		}
		else
		{
			foreach ($context['SPortal']['blocks'][3] as $block)
			{
				template_block($block);
				echo '
			</div>
		</div>
		<div class="ehPortal_row">
			<div class="ehPortal_cell" style="max-width: 100vw;min-width: 98vw;padding: 0em;margin: 0em auto;position: relative;">';
			}
		}
	}

	echo '
			</div>';

	if (!empty($modSettings['showright']) && !empty($context['SPortal']['blocks'][4]))
	{
		$units = !empty($modSettings['rightwidth']) && strpos($modSettings['rightwidth'], 'px') === false && strpos($modSettings['rightwidth'], '%') === false ? 'px' : '';
		if (empty($_SESSION['isPortalMobile']))
			echo '
			<div class="ehPortal_cell" id="sp_right"', $context['SPortal']['sides'][4]['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : (!empty($modSettings['rightwidth']) ? ' style="width: ' . $modSettings['rightwidth'] . $units . ';"' : ''), '>';
		else
			echo '
			<div class="ehPortal_cell" id="sp_right"', $context['SPortal']['sides'][4]['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : ' style="min-width: 100vw;padding: 0em;margin: 0em auto;position: relative;"', '>';

		if (empty($_SESSION['isPortalMobile']))
		{
			foreach ($context['SPortal']['blocks'][4] as $block)
				template_block($block);
		}
		else
		{
			foreach ($context['SPortal']['blocks'][4] as $block)
			{
				template_block($block);
				echo '
			</div>
		</div>
		<div class="ehPortal_row">
			<div class="ehPortal_cell"', $context['SPortal']['sides'][4]['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : ' style="min-width: 100vw;padding: 0em;margin: 0em auto;position: relative;"', '>';
			}
		}

		echo '
			</div>';
	}
	echo '
		</div>
	</div>';

	if (!empty($context['SPortal']['blocks'][6]))
	{

		if (empty($_SESSION['isPortalMobile']))
		{
			echo '
	<div id="sp_footer">';
			foreach ($context['SPortal']['blocks'][6] as $block)
				template_block($block);
			echo '
	</div>
	<br />';
		}
		else
		{
			if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'portal' && $modSettings['sp_portal_mode'] == 1)
				echo '
		<div class="ehPortal_table ehPortal_footer" id="sp_footer" style="padding: 0em;margin: 0em auto;position: relative;">';
			else
				echo '
		<div class="ehPortal_table" id="sp_footer" style="padding: 0em;margin: 0em auto;position: relative;">';
			foreach ($context['SPortal']['blocks'][6] as $block)
			{
				echo '
			<div class="ehPortal_row">
				<div class="ehPortal_cell" style="min-width: 100vw;padding: 0em;margin: 0em auto;position: relative;">';
				template_block($block);
				echo '
				</div>
			</div';
			}
			echo '
		</div>
		<br />';
		}
	}
}

function template_block($block)
{
	global $context, $modSettings, $txt;

	if (empty($block) || empty($block['type']))
		return;

	$mobileFront = '';
	if (!empty($_SESSION['isPortalMobile'])) {
		if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'portal' && $modSettings['sp_portal_mode'] == 1) {
			$mobileFront = '_front';
		}
	}

	if ($block['type'] == 'sp_boardNews')
	{
		echo '
			<div class="ehPortal_left ehPortalNews sp_block_section', isset($context['SPortal']['sides'][$block['column']]['last']) && $context['SPortal']['sides'][$block['column']]['last'] == $block['id'] && ($block['column'] != 2 || empty($modSettings['articleactive'])) ? '_last' . $mobileFront : '', '">';

		$block['type'](array_merge($block['parameters'], array('style' => $block['style'])), $block['id']);

		echo '
			</div>';

		return;
	}

	if (isset($txt['sp_custom_block_title_' . $block['id']]))
		$block['label'] = $txt['sp_custom_block_title_' . $block['id']];

	echo '
			<div style="position: relative;" class="ehPortal_left">';

	template_block_default($block);
	echo '
			</div>';
}

function template_block_default($block)
{
	global $context, $modSettings, $settings;

	$blockClass = $block['type'] == 'sp_shoutbox' ? 'ehshout_title' : 'ehblock_title';
	$portalMode = empty($_REQUEST['action']) && $modSettings['sp_portal_mode'] == 1 ? 'portal' : '';
	$mobileFront = '';
	if (!empty($_SESSION['isPortalMobile'])) {
		if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'portal' && $modSettings['sp_portal_mode'] == 1 && isset($context['SPortal']['sides'][$block['column']]['last']) && $block['type'] == 'sp_news') {
			$mobileFront = '_front';
		}
		elseif ($portalMode == 'portal' && isset($context['SPortal']['sides'][$block['column']]['last']) && $block['type'] == 'sp_news')
			$mobileFront = '_front';

		$blockClass = $blockClass . ' sp_allblock_title';
	}
	$mobileTitle = !empty($_SESSION['isPortalMobile']) ? 'position: relative;' : 'position: static;';
	$mobileHidden = !empty($_SESSION['isPortalMobile']) ? ' style="overflow: hidden;border: none;width: 99vw;min-width: 99vw;max-width: 99vw;margin: 0 auto;' . ($block['type'] == 'sp_shoutbox' ? 'right: 0.25rem !important;' : 'left: 0em;') . '"' : '';
	if ($block['type'] == 'sp_news' && !empty($modSettings['sp_bullets']) && strpos($block['style']['body']['class'], 'roundframe') === false)
		echo '
	<div' . $mobileHidden. ' class="sp_news_below sp_block_section', isset($context['SPortal']['sides'][$block['column']]['last']) && $context['SPortal']['sides'][$block['column']]['last'] == $block['id'] && ($block['column'] != 2 || empty($modSettings['articleactive'])) ? '_last' . $mobileFront : '', '">';
	else
		echo '
	<div' . $mobileHidden. ' class="sp_block_section', isset($context['SPortal']['sides'][$block['column']]['last']) && $context['SPortal']['sides'][$block['column']]['last'] == $block['id'] && ($block['column'] != 2 || empty($modSettings['articleactive'])) ? '_last' . $mobileFront : '', '">';

	if (empty($block['style']['no_title']))
	{
		$block['collapsed'] = !empty($block['collapse_view']) && empty($block['collapsed']) ? 1 : $block['collapsed'];
		echo '
		<div style="' . $mobileTitle . '" class="', $blockClass . ' ' . (in_array($block['style']['title']['class'], array('titlebg', 'titlebg2')) ? 'title_bar' : 'cat_bar'), '"', !empty($block['style']['title']['style']) ? ' style="' . $block['style']['title']['style'] . '"' : '', '>
			<h3 class="', $block['style']['title']['class'], '">';

		if (empty($block['force_view']))
			echo '
				<a class="sp_float_right_title" href="javascript:void(0);" onclick="sp_collapseBlock(\'', $block['id'], '\')"><span id="sp_collapse_', $block['id'], '" class="', ($block['collapsed'] ? 'toggle_down' : 'toggle_up'), '"></span></a>';

		echo '
				', parse_bbc($block['label']), '
			</h3>
		</div>
		<div class="sp_block_title" id="sp_block_' . $block['id'] . '"', $block['collapsed'] && empty($block['force_view']) && empty($block['style']['no_title']) ? ' style="display: none;"' : (!empty($_SESSION['isPortalMobile']) ? ' style="left: -0.315em;"' : ''), '>';
	}
	else
		echo '
		<div class="sp_block_title" id="sp_block_' . $block['id'] . '"', $block['collapsed'] && empty($block['force_view']) && empty($block['style']['no_title']) ? ' style="display: none;"' : (!empty($_SESSION['isPortalMobile']) ? ' style="left: -0.315em;"' : ''), '>';

	if (strpos($block['style']['body']['class'], 'roundframe') !== false)
	{
		echo '
			<span class="upperframe"><span></span></span>';
	}

	if ($block['type'] == 'sp_news')
		echo '
			<div class="', (empty($block['style']['body']['class']) ? 'sp_news_body' : 'sp_news_body ' . $block['style']['body']['class']), '" style="margin-top: 0;">';
	else
		echo '
			<div', empty($block['style']['body']['class']) ? '' : ' class="' . $block['style']['body']['class'] . '"', ' style="margin-top: 0;">';

	if (empty($block['style']['no_body']) && strpos($block['style']['body']['class'], 'roundframe') === false)
	{
		echo '
				<span class="topslice"><span></span></span>';
	}

	echo '
				<div class="', $block['type'] !== 'sp_menu' ? 'sp_block' : 'sp_content_padding', '"', !empty($block['style']['body']['style']) ? ' style="' . (!empty($block['calendar_style']) ? $block['calendar_style'] : '') . $block['style']['body']['style'] . '"' : ($block['type'] === 'sp_calendar' ? ' style="overflow: hidden;"' : ''), '>';

	$block['type']($block['parameters'], $block['id']);

	echo '
				</div>';

	if (empty($block['style']['no_body']) && strpos($block['style']['body']['class'], 'roundframe') === false)
	{
		echo '
				<span class="botslice"><span></span></span>';
	}
	elseif (strpos($block['style']['body']['class'], 'roundframe') !== false)
		echo '
				<div style="padding-bottom: 10px;"></div>';
	echo '
			</div>';

	if (strpos($block['style']['body']['class'], 'roundframe') !== false)
	{
		echo '
			<span class="lowerframe"><span></span></span>';
	}

	echo '
		</div>
	</div>';
}

?>