<?php
// Version: 1.3; PortalShoutbox

function template_shoutbox_all()
{
	global $context;
	template_shoutbox_all_default();
}

function template_shoutbox_all_default()
{
	global $context, $txt;

	$mobileTitle = !empty($_SESSION['isPortalMobile']) ? 'position: relative;' : 'position: static;';
	$mobileBody = !empty($_SESSION['isPortalMobile']) ? 'clear: both;box-sizing: border-box;overflow: hidden;margin: 0 auto;display: block;width: 97vw;min-width: 97vw;left: 0px;max-width: 102vw;border: 0px;position: relative;font-size: large;' : 'position: static;';
	$histBody = !empty($_SESSION['isPortalMobile']) ? 'clear: both;box-sizing: border-box;display: block;overflow: hidden;width: 90vw;min-width: 90vw;max-width: 102vw;position: relative;font-size: large;border-top: 1px dotted rgba(255, 0, 0, .5);' : 'position: static;';
	if (!empty($context['SPortal']['shouts_history']))
		echo '
	<form id="ehshout_history" method="POST" action="', $context['ehportal_page_index'], '">';

	echo '
	<div class="cat_bar' . (!empty($_SESSION['isPortalMobile']) ?  ' sp_shoutbox_title' : '') . '" style="' . $mobileTitle . '">
		<h3 class="catbg">
			', (!empty($context['SPortal']['shoutbox']['name']) ? $context['SPortal']['shoutbox']['name'] : ''), '
		</h3>
	</div>
	<div class="windowbg" style="overflow-x: hidden;">
		<span class="topslice"><span></span></span>
		<div class="sp_content_padding">
			<div class="shoutbox_page_index smalltext" style="' . $mobileBody . '">', $context['page_index'], '
			</div>
			<div class="shoutbox_body" style="">
				<ul class="shoutbox_list_all" id="shouts"  style="' . $histBody . '">';

	$x = 1;
	if (!empty($context['SPortal']['shouts_history']))
		foreach ($context['SPortal']['shouts_history'] as $shout)
		{
			$shout['text'] = ehshout_bbcode_filter($shout['text'], $shout['allowed_bbc']);
			echo '
					<li id="shoutindex' . $x . '" style="padding-left: 5px;" class="shouts smalltext">
						', !$shout['is_me'] ? '<strong>' . $shout['author']['link'] . ':</strong>' : '<span style="color: ' . $shout['author']['color'] . ';">' . $shout['author']['name'] . ':</span>', '
					</li>
					<li style="padding-left: 10px;" class="shouts smalltext">
						', str_replace('ignored_shout', 'history_ignored_shout', parse_bbc($shout['text'], true, '', $shout['allowed_bbc'])), '
					</li>
					<li style="padding-left: 5px;position: relative;" class="smalltext shoutbox_time"><div style="display: inline;position: relative;left: 2px;bottom: 0px;vertical-align: bottom;">', $shout['delete_link_js_hist'], '</div><div style="position: relative;display: inline;padding-left: 5px;bottom: 5px;left: 5px;">', $shout['time'], '</div></li>';
			$x++;
		}
	else
			echo '
					<li class="smalltext">', $txt['sp_shoutbox_no_shout'], '</li>';

	echo '
				</ul>
			</div>
			<div class="shoutbox_page_index smalltext" style="' . $mobileBody . '">', $context['page_index'], '</div>
		</div>
		<span class="botslice"><span></span></span>
	</div>';
	if (!empty($context['SPortal']['shouts_history']))
		echo '
	<input class="ehShoutSess" type="hidden" name="', $context['session_var'], '" value="', $context['session_id'], '" />
	<input style="display: none;" type="submit" value="submit" />
	</form>';

	// <input type="hidden" id="shoutbox_id" name="shoutbox_id" value="', $context['SPortal']['shouts_history'][0]['id'], '" />
}

function template_shoutbox_embed($shoutbox)
{
	global $context, $scripturl, $settings, $txt, $user_info, $boarddir, $sourcedir, $modSettings;
	list($z, $colors, $colornames) = array(0, explode('|', $txt['sp_bbc_colors']), explode('|', $txt['sp_bbc_color_names']));
	$bbcScale = !empty($shoutbox['shout_bbc_scale']) && intval($shoutbox['shout_bbc_scale']) < 101 ? intval(abs($shoutbox['shout_bbc_scale'])) : (!empty($shoutbox['shout_bbc_scale']) && intval($shoutbox['shout_bbc_scale']) > 100 ? 100 : 85);
	$smileyScale = !empty($shoutbox['shout_smiley_scale']) && intval($shoutbox['shout_smiley_scale']) < 101 ? intval(abs($shoutbox['shout_smiley_scale'])) : (!empty($shoutbox['shout_smiley_scale']) && intval($shoutbox['shout_smiley_scale']) > 100 ? 100 : 85);
	$bbcStyle = 'zoom: ' . number_format(($bbcScale/100), 2, '.', '') . ';-moz-transform: scale(' . number_format(($bbcScale/100), 2, '.', '') . ');';
	$smileyStyle = 'zoom: ' . number_format(($smileyScale/100), 2, '.', '') . ';-moz-transform: scale(' . number_format(($smileyScale/100), 2, '.', '') . ');';
	$mobileBody = !empty($_SESSION['isPortalMobile']) ? 'clear: both;box-sizing: border-box;overflow: hidden;margin: 0 auto;display: block;width: 90vw;min-width: 90vw;left: 0px;max-width: 102vw;border: 0px;position: relative;font-size: large;' : 'position: static;';
	echo '
		<div class="shout_box" style="' . $mobileBody . '">
			<div class="shoutbox_header" style="box-sizing: border-box;position: relative;', (!empty($_SESSION['isPortalMobile']) ? 'width: 95%;' : ''), '">
				<div id="shoutbox_load_', $shoutbox['id'], '" style="float: right; display: inline;position: relative;', (!empty($_SESSION['isPortalMobile']) ? 'right: 1.5em;' : ''), '"><img src="', $settings['sp_images_url'], '/loading.gif" alt="" /></div>
				<button style="border: 0px;vertical-align: top;padding: 0px;" type="button" onclick="EhShoutRefresh(', $shoutbox['id'], ');">', sp_embed_image('refresh'), '</button> <button type="button" style="border: 0px;vertical-align: top;padding: 0px;" onclick="EhShoutHistory(\'', $shoutbox['id'], '\');">', sp_embed_image('history'), '</button>';

	if ($context['can_shout'])
		echo ' <button id="ehSmileyClearTimer(\'' . $shoutbox['id'] . '\');ehSmileyMainClick_' . $shoutbox['id'] . '" type="button" style="border: 0px;vertical-align: top;padding: 0px;" onclick="ehSmileyMainClick(\'' . $shoutbox['id'] . '\', \'', $settings['default_theme_url'], '/images/sp_shoutbox\', \'', $txt['sp_more_smileys'], '\', \'', $txt['sp_less_smileys'], '\');sp_collapse_object(\'sb_smiley_', $shoutbox['id'], '\', false); return false;">', sp_embed_image('smiley'), '</button> <button type="button" style="border: 0px;vertical-align: top;padding: 0px;" onclick="'. (!empty($modSettings['enableBBC']) ? 'sp_collapse_object(\'sb_style_' . $shoutbox['id'] . '\', false); return false;' : '') . '">', sp_embed_image('style'), '</button>';

	echo '
			</div>';

	if ($context['can_shout'])
	{
		echo '
			<div class="shoutbox_smileys" id="sp_object_sb_smiley_', $shoutbox['id'], '" style="display: none;padding: 0.5rem 0.2rem 0.2rem 0.2rem !important;' . $smileyStyle . '">';

		foreach ($shoutbox['smileys']['normal'] as $smiley)
		{
			if (empty($modSettings['simple_smileys_useall']))
				echo '
				<a href="javascript:void(0);" onclick="replaceText(\' ', $smiley['code'], '\', document.getElementsByClassName(\'new_shout_', $shoutbox['id'], '\')[0]); return false;"><img src="', $settings['smileys_url'], '/', $smiley['filename'], '" alt="', $smiley['description'], '" title="', $smiley['description'], '" /></a>';
			else
			{
				$path = array_pop(explode('/', $settings['smileys_url']));
				$newPath = getSimpleSmileyImgShoutbox($path, $smiley['filename']);
				$file = rtrim($settings['smileys_url'], $path) . $newPath . '/' . $smiley['filename'];
				echo '
				<a href="javascript:void(0);" onclick="replaceText(\' ', $smiley['code'], '\', document.getElementsByClassName(\'new_shout_', $shoutbox['id'], '\')[0]); return false;"><img src="', $file, '" alt="', $smiley['description'], '" title="', $smiley['description'], '" /></a>';
			}
		}

		if (!empty($shoutbox['smileys']['popup']))
		{
				echo '
				<a onclick="ehSmileyClearTimer(\'' . $shoutbox['id'] . '\');ehSmileySetTimer(\'' . $shoutbox['id'] . '\', \'' . $settings['default_theme_url'] . '/images/sp_shoutbox\', \'' . $txt['sp_more_smileys'], '\', \'' . $txt['sp_less_smileys'] . '\');sp_showMoreSmileys(\'' . $shoutbox['id'] . '\', \'' . $txt['more_smileys_title'] . '\', \'' . $txt['more_smileys_pick'] . '\', \'' . $txt['more_smileys_close_window'] . '\', \'' . $settings['theme_url'] . '\', \'' . $settings['smileys_url'] . '\', \'' . $settings['default_theme_url'] . '/images/sp_shoutbox\', \'' . $txt['sp_more_smileys'] . '\', \'' . $txt['sp_less_smileys'] . '\'); return false;" href="javascript:void(0);"><img id="spSmileyPopupPlus_' . $shoutbox['id'] . '" style="padding: 0rem 0rem 0.2rem 0.2rem !important;" src="' . $settings['default_theme_url'] . '/images/sp_shoutbox/plus.png" alt="[' . $txt['more_smileys'] . ']" title="' . $txt['sp_more_smileys'] . '" /></a>';
		}

		echo '
			</div>
			<div id="spSmileyPopup_' . $shoutbox['id'] . '" class="ehshout_down shoutbox_more_smileys" style="display: none;' . $smileyStyle . '"><span></span></div>
			<div class="shoutbox_styles" id="sp_object_sb_style_', $shoutbox['id'], '" style="display: none;padding: 0.5rem 0.2rem 0.5rem 0.2rem !important;' . $bbcStyle . '">';

		foreach ($shoutbox['bbc'] as $image => $tag)
		{
			if (!in_array($tag['code'], $shoutbox['allowed_bbc']))
				continue;

			if (!in_array($tag['code'], array('size', 'font', 'color', 'me'))) {
				if (!isset($tag['after']))
					echo '
					<a href="javascript:void(0);" onclick="replaceText(\'', $tag['before'], '\', document.getElementsByClassName(\'new_shout_', $shoutbox['id'], '\')[0])">';
				else
					echo '<a href="javascript:void(0);" onclick="surroundText(\'', $tag['before'], '\', \'', $tag['after'], '\', document.getElementsByClassName(\'new_shout_', $shoutbox['id'], '\')[0])">';

				echo '<img class="ehshoutbbcode_' . $tag['code'] . '" onmouseover="style_highlight(this, true);" onmouseout="if (window.style_highlight) style_highlight(this, false)" src="', $settings['default_images_url'], '/sp_shoutbox/', $tag['img'], '" alt="', $tag['description'], '" title="', $tag['description'], '" style="width: 1.3rem; height: 1.3rem; background-image: url(', $settings['default_images_url'], '/sp_shoutbox/bbc_bg.png); margin: 1px 2px 1px 1px;vertical-align: text-bottom;padding-top: 0.3125em;" /></a>';
			}
			else {
				echo '<div id="ehshoutbbcode_' . $tag['code'] . $shoutbox['id'] . '" style="display: inline;" onclick="ehPortalShoutClicker(\'' . $tag['code'] . $shoutbox['id'] . '\')">';

				echo '<img class="ehshoutbbcode_' . $tag['code'] . '" onmouseover="style_highlight(this, true);" onmouseout="if (window.style_highlight) style_highlight(this, false);" src="', $settings['default_images_url'], '/sp_shoutbox/', $tag['img'], '" alt="', $tag['description'], '" title="', $tag['description'], '" style="width: 1.3rem; height: 1.3rem; background-image: url(', $settings['default_images_url'], '/sp_shoutbox/bbc_bg.png); margin: 1px 2px 1px 1px;vertical-align: text-bottom;padding-top: 0.3125em;" /></div>';

				switch($tag['code']) {
					case 'size':
						// onmouseout="ehportal_closebbcdrop(\'' . $tag['code'] . $shoutbox['id'] . '\')"
						echo '<div style="display: inline;vertical-align: top;" id="ehshoutbbcodediv_' . $tag['code'] . $shoutbox['id'] . '">
				<select onmouseout="ehcancelBubble()" id="ehshoutbbcodedrop_' . $tag['code'] . $shoutbox['id'] . '" style="display: none;" onchange="ehportal_surroundText(\'' . $tag['code'] . '\', this.options[this.selectedIndex].value,\'' . $shoutbox['id'] . '\')">
					<option value="0">' . $txt['sp_bbc_dropdown'] . '</option>
					<option style="font-size: 1.00rem;" value="1"><span style="font-size: 1.00rem;">1</span></option>
					<option style="font-size: 1.25rem;" value="2"><span style="font-size: 1.25rem;">2</span></option>
					<option style="font-size: 1.50rem;" value="3"><span style="font-size: 1.50rem;">3</span></option>
					<option style="font-size: 1.75rem;" value="4"><span style="font-size: 1.75rem;">4</span></option>
					<option style="font-size: 2.00rem;" value="5"><span style="font-size: 2.00rem;">5</span></option>
					<option style="font-size: 2.25rem;" value="6"><span style="font-size: 2.25rem;">6</span></option>
				</select></div>';
						break;
					case 'font':
						echo '<div style="display: inline;vertical-align: top;" id="ehshoutbbcodediv_' . $tag['code'] . $shoutbox['id'] . '">
				<select onmouseout="ehcancelBubble()" id="ehshoutbbcodedrop_' . $tag['code'] . $shoutbox['id'] . '" style="display: none;" onchange="ehportal_surroundText(\'' . $tag['code'] . '\', this.options[this.selectedIndex].value,\'' . $shoutbox['id'] . '\')">
					<option value="0">' . $txt['sp_bbc_dropdown'] . '</option>
					<option style="font-family: Engravers MT;" value="Engravers MT"><span style="font-family: Engravers MT;">Engravers MT</span></option>
					<option style="font-family: Courier New;" value="Courier New"><span style="font-family: Courier New;">Courier New</span></option>
					<option style="font-family: Comic Sans MS;" value="Comic Sans MS"><span style="font-family: Comic Sans MS;">Comic Sans MS</span></option>
					<option style="font-family: Lucida Sans Unicode;" value="Lucida Sans Unicode"><span style="font-family: Lucida Sans Unicode;">Lucida Sans Unicode</span></option>
					<option style="font-family: Impact;" value="Impact"><span style="font-family: Impact;">Impact</span></option>
					<option style="font-family: Mistral;" value="Mistral"><span style="font-family: Mistral;">Mistral</span></option>
				</select></div>';
						break;
					case 'color':
						echo '<div style="display: inline;vertical-align: top;" id="ehshoutbbcodediv_' . $tag['code'] . $shoutbox['id'] . '">
				<select onmouseout="ehcancelBubble()" id="ehshoutbbcodedrop_' . $tag['code'] . $shoutbox['id'] . '" style="display: none;" onchange="ehportal_surroundText(\'' . $tag['code'] . '\', this.options[this.selectedIndex].value,\'' . $shoutbox['id'] . '\')">
					<option value="0">' . $txt['sp_bbc_dropdown'] . '</option>';
						foreach ($colors as $color) {
							echo '
					<option style="color: ' . $color . ';" value="' . $color . '"><span>' . $colornames[$z] . '</span></option>';
							$z++;
						}
						echo '
				</select></div>';
						break;
					default:
						echo '<div style="display: inline;" id="ehshoutbbcodediv_' . $tag['code'] . $shoutbox['id'] . '">
					<input onmouseout="ehcancelBubble()" id="ehshoutbbcodedrop_' . $tag['code'] . $shoutbox['id'] . '" style="display: none;" value="" type="text" placeholder="' . $txt['sp_bbc_input_name'] . '" onchange="ehportal_inp_surroundText(\'' . $tag['code'] . '\', this.value,\'' . $shoutbox['id'] . '\')" /></div>';
				}
			}
		}

		echo '
			</div>';
	}

	if (!empty($shoutbox['warning']))
			echo '
			<div class="shoutbox_warning smalltext">', $shoutbox['warning'], '</div>';

	// this will be populated via jQuery & the shoutbox_refresh function but populate it here at its onset
	$units = !empty($shoutbox['height']) && strpos($shoutbox['height'], 'px') === false && strpos($shoutbox['height'], '%') === false ? 'px' : '';
	$file = !empty($modSettings['sp_sbSound']) ? $modSettings['sp_sbSound'] : 'default.mp3';
	echo '
			<div class="message_box message_box_', $shoutbox['id'],'" id="message_box_', $shoutbox['id'],'" style="overflow: hidden;', (!empty($_SESSION['isPortalMobile']) ? 'width: 95%;' : ''), '">
				<ul class="shoutbox_list_compact shouts_', $shoutbox['id'], '" id="shouts_', $shoutbox['id'], '"', !empty($shoutbox['height']) ? ' style="height: ' . $shoutbox['height'] . $units . ';"' : '', '>';

	if (!empty($shoutbox['shouts']))
	{
		list($x, $audio) = array(0, '');
		$a = end($shoutbox['shouts']);
		foreach ($shoutbox['shouts'] as $shout)
		{
			$x++;
			$shout['text'] = ehshout_bbcode_filter($shout['text'], $shout['allowed_bbc']);
			//$shout['text'] = parse_bbc($shout['text'], true, '', $shout['allowed_bbc']);
			echo '
					<li ', ($x == count($shoutbox['shouts']) ? 'id="lastshout_' . $shoutbox['id'] . '" ' : ''),'class="shouts smalltext">', ($shout['is_me'] ? '<i><span style="color: ' . $shout['author']['color'] . '">' . $shout['author']['name']. ':</span></i> ' : '<strong>' . $shout['author']['private'] . '</strong>: '),  $shout['text'], '<br />', !empty($shout['delete_link_js']) ? '<span class="shoutbox_delete">' . $shout['delete_link_js'] . '</span>' : '' , '<span class="smalltext shoutbox_time">', $shout['time'], '</span></li>';
		}
	}
	else
		echo '
					<li class="smalltext">', $txt['sp_shoutbox_no_shout'], '</li>';

	echo '
				</ul>
			</div>';

	if ($context['can_shout'])
		echo '
			 <div class="user_info">
				<input onkeypress="EhShoutKeyDown(event, ' . $shoutbox['id'] . ');" maxlength="300" name="shout_message_' . $shoutbox['id'] . '" id="shout_message_' . $shoutbox['id'] . '" class="new_shout_' . $shoutbox['id'] . '" type="text" placeholder="Type Message Hit Enter" autocomplete="off" />
				<div style="padding: 4px;"><button class="button" onclick="EhShoutEnter(' . $shoutbox['id'] . ');" name="shout_username_', $shoutbox['id'], '" id="shout_username_', $shoutbox['id'], '" type="button" value="', $user_info['name'],'">', $txt['sp_shoutbox_button'], '</button></div>
			</div>';

	echo '
		</div>
	<div class="ehshoutboxflag" id="ehshoutboxflag', $shoutbox['id'], '" style="display: none;">', $shoutbox['id'], '</div>
	<script>
		var last_refresh_', $shoutbox['id'], ' = ', time(), ';
		var ehshoutreverse = ', !empty($shoutbox['reverse']) ? 1 : 0, ';
		var ehshoutboxid = ', $shoutbox['id'], ';
		var ehShoutSess = ["', $context['session_var'], '","', $context['session_id'], '"];
		if (typeof ehshoutrefresh != "object")
			var ehshoutrefresh = [];
		ehshoutrefresh[' . $shoutbox['id'] . '] = ', $shoutbox['refresh'], ';';

	if ($shoutbox['reverse'])
		echo '
		var objDiv = document.getElementById("shouts_', $shoutbox['id'], '");
		objDiv.scrollTop = objDiv.scrollHeight;';

	// Setup the data for the popup smileys.
	if (!empty($shoutbox['smileys']['popup']))
	{
		echo '
		if (sp_smileys == undefined)
			var sp_smileys = [';
		foreach ($shoutbox['smileys']['popup'] as $smiley)
		{
			echo '
					["', $smiley['code'], '","', $smiley['filename'], '","', $smiley['js_description'], '"]';
			if (empty($smiley['last']))
				echo ',';
		}
		echo ']';
	}

	echo '
	</script>';

	// shout audio mutation callback
	$refreshTime = !empty($shoutbox['refresh']) ? intval($shoutbox['refresh']) * 1000 : 1000;
	if (!empty($shoutbox['shouts']) && !empty($modSettings['sp_sbSoundEnable']) && !empty($user_info['ehportal_enable_audio']))
		echo '
	<script>
		$(function() {
			var targetNode = document.getElementById("message_box_', $shoutbox['id'],'");
			var config = {attributes: false, childList: true, subtree: false};
			var targetTime = [], lastEhShoutId = [], oldEhShoutId = [];
			var oldTime = [];
			var targetUser = [];
			var targetRefreshTime = [];
			var targetNowTime = [];
			oldTime["', $shoutbox['id'], '"] = 0;
			var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
			var callback = function(mutationsList) {
				for(var mutation of mutationsList) {
					if (mutation.type == "childList") {
						oldEhShoutId["', $shoutbox['id'], '"] = typeof oldEhShoutId["', $shoutbox['id'], '"] !== "undefined" && oldEhShoutId["', $shoutbox['id'], '"] != 0 ? oldEhShoutId["', $shoutbox['id'], '"] : 0;
						lastEhShoutId["', $shoutbox['id'], '"] = document.getElementById("ehlastshoutId_', $shoutbox['id'], '") ? document.getElementById("ehlastshoutId_', $shoutbox['id'], '").innerHTML : 0;
						targetTime["', $shoutbox['id'], '"] = document.getElementById("ehlasttime_', $shoutbox['id'], '") ? document.getElementById("ehlasttime_', $shoutbox['id'], '").innerHTML : 0;
						targetUser["', $shoutbox['id'], '"] = document.getElementById("ehlastuserid_', $shoutbox['id'], '") ? document.getElementById("ehlastuserid_', $shoutbox['id'], '").innerHTML : 0;
						targetRefreshTime["', $shoutbox['id'], '"] = document.getElementById("ehrefreshtime_', $shoutbox['id'], '") ? document.getElementById("ehrefreshtime_', $shoutbox['id'], '").innerHTML : 0;
						targetNowTime["', $shoutbox['id'], '"] = document.getElementById("ehnowtime_', $shoutbox['id'], '") ? document.getElementById("ehnowtime_', $shoutbox['id'], '").innerHTML : 0;
						if (oldEhShoutId["', $shoutbox['id'], '"] != lastEhShoutId["', $shoutbox['id'], '"] && oldTime["', $shoutbox['id'], '"] != targetTime["', $shoutbox['id'], '"] && oldTime["', $shoutbox['id'], '"] != 0 && targetUser["', $shoutbox['id'], '"] != 0 && targetUser["', $shoutbox['id'], '"] != parseInt("', $user_info['id'], '"))
						{
							spSound();
							oldEhShoutId["', $shoutbox['id'], '"] = parseInt(lastEhShoutId["', $shoutbox['id'], '"]);
						}
						else
							oldTime["', $shoutbox['id'], '"] = targetTime["', $shoutbox['id'], '"];
					}
				}
			};
			var observer = new MutationObserver(callback);
			observer.observe(targetNode, config);
		});
	</script>';
}

function template_shoutbox_refresh()
{
	global $context, $txt, $modSettings, $user_info, $boardurl, $boarddir;

	$id = !empty($_POST['shoutbox_id']) ? $_POST['shoutbox_id'] : (!empty($context['SPortal']['shouts']) ? $context['SPortal']['shouts'][0]['shoutbox_id'] : 0);
	list($time, $userid, $audio, $refresh, $nowTime) = array(0, 0, '', 100, time());
	$file = !empty($modSettings['sp_sbSound']) ? $modSettings['sp_sbSound'] : 'default.mp3';
	$units = !empty($context['SPortal']['shouts'][0]['height']) && strpos($context['SPortal']['shouts'][0]['height'], 'px') === false && strpos($context['SPortal']['shouts'][0]['height'], '%') === false ? 'px' : '';
	// shout audio
	if (!empty($context['SPortal']['shouts']) && !empty($modSettings['sp_sbSoundEnable']) && !empty($user_info['ehportal_enable_audio']))
	{
		$refArray = $context['SPortal']['shouts'];
		$key = empty($context['SPortal']['shouts'][0]['reverse']) ? 0 : count($refArray) - 1;
		$refresh = $refArray[$key]['refresh'];
		$userid = $refArray[$key]['author']['id'];
		$time = $refArray[$key]['raw_time'];
		$_SESSION[$time] = empty($_SESSION[$time]) ? $time : '';
		$audio = !empty($_SESSION[$time]) ? '<audio onmousemove="this.play();" id="ehSound_' . $time . '" src="' . $boardurl . '/sp_shout_sounds/' . $file . '"></audio>' : '';
	}
	else {
		$audio = '';
	}

	echo '
				<div style="display: none;" id="ehaudiofile_', $id, '">', rtrim($file, '.mp3'), '</div>
				<div style="display: none;" id="ehlasttime_', $id, '">', $time, '</div>
				<div style="display: none;" id="ehlastshoutId_', $id, '">', (!empty($context['SPortal']['shouts']) && !empty($context['SPortal']['shouts'][0]['id_shout']) ? $context['SPortal']['shouts'][0]['id_shout'] : '0'), '</div>
				<div style="display: none;" id="ehlastuserid_', $id, '">', $userid, '</div>
				<div style="display: none;" id="ehrefreshtime_', $id, '">', $refresh, '</div>
				<div style="display: none;" id="ehnowtime_', $id, '">', $nowTime, '</div>
				<ul class="shoutbox_list_compact shouts_', $id, '" id="shouts_', $id, '"', !empty($context['SPortal']['shouts'][0]['height']) ? ' style="height: ' . $context['SPortal']['shouts'][0]['height'] . $units . ';"' : '', '>';

	if (!empty($context['SPortal']['shouts']) && !empty($id))
	{
		$x = 0;
		if (count($context['SPortal']['shouts']) > 1)
			foreach ($context['SPortal']['shouts'] as $shout)
			{
				$x++;
				if (empty($context['SPortal']['shouts'][0]['reverse']) && $x != 1)
					$audio = '';
				elseif (!empty($context['SPortal']['shouts'][0]['reverse']) && $x != count($context['SPortal']['shouts']))
					$audio = '';
				$shout_text = ehshout_bbcode_filter($shout['text'], $shout['allowed_bbc']);
				$shout['text'] = censorText($shout_text);
				echo '
					<li ', ($x == count($context['SPortal']['shouts']) ? 'id="lastshout_' . $shout['shoutbox_id'] . '" ' : ''),'class="shouts smalltext">', ($shout['is_me'] ? '<i><span style="color: ' . $shout['color'] . '">' . $shout['name']. ':</span></i> ' : '<strong>' . $shout['author']['private'] . '</strong>: '),  preg_replace('~<a([^>]+>)([^<]+)</a>~', (!empty($shout['disable_links']) ? '<a href="#">' . $txt['sp_link'] . '</a>': '<a$1' . $txt['sp_link'] . '</a>'), autoShoutLink(parse_bbc($shout['text'], true, '', $shout['allowed_bbc']))), '<br />', !empty($shout['delete_link_js']) ? '<span class="shoutbox_delete">' . $shout['delete_link_js'] . '</span>' : '' , '<span class="smalltext shoutbox_time">', $shout['time'], '</span>' . $audio . '</li>';
			}
	}
	else
			echo '
					<li class="smalltext">', $txt['sp_shoutbox_no_shout'], '</li>';

	echo '
				</ul>
				<script>
					ehPortalShoutChanger();
					if (document.getElementById("shoutLogin"))
					{
						document.getElementById("shout_message_' . $id . '").disabled = true;
						document.getElementById("shout_message_' . $id . '").value = "";
					}';

	if (!empty($context['SPortal']['shouts'][0]['reverse']))
		echo '
					var objDiv = document.getElementById("shouts_', $id, '");
					objDiv.scrollTop = objDiv.scrollHeight;';

	echo '
				</script>';
}

?>