<?php
// Version: 1.3; EhPortal

// General strings
$txt['sp-forum'] = 'Forum';
$txt['sp-portal'] = 'Portal';
$txt['sp-adminTitle'] = 'EhPortal Admin';
$txt['sp-adminCatTitle'] = 'EhPortal';
$txt['sp-add_article'] = 'Add as Article';
$txt['sp-remove_article'] = 'Remove from Articles';
$txt['sp_add_article_button'] = 'Add Article';
$txt['sp_remove_article_button'] = 'Remove Article';
$txt['sp-dot'] = 'Dot';
$txt['sp-arrow'] = 'Arrow';
$txt['sp-star'] = 'Star';
$txt['sp_yes'] = 'Yes';
$txt['sp_no'] = 'No';
$txt['sp_move'] = 'Move';
$txt['sp_fixbox'] = 'Fix Total Shouts';
$txt['sp_all'] = 'All';
$txt['sp_link'] = '[link]';
$txt['sp_function_unknown_label'] = 'Unknown Block Type';
$txt['sp_welcome_guest'] = 'Welcome <strong>%1$s</strong>. <div>Please <a href="%2$s" target="_self">log in</a>.</div>';

// Block specific strings
$txt['sp-usertmessage'] = 'Total Messages';
$txt['sp-usernmessage'] = 'New Messages';
$txt['sp-articlesComments'] = 'Comments';
$txt['sp-articlesViews'] = 'Views';
$txt['sp-articlesPages'] = 'Pages';
$txt['sp-downloadsCount'] = 'Downloads';
$txt['sp-downloadsPoster'] = 'Posted by';
$txt['sp_calendar_noEventsFound'] = 'Sorry! There are no calendar events available at the moment.';
$txt['sp_calendar_events'] = 'Today\'s Events';
$txt['sp_calendar_upcomingEvents'] = 'Upcoming Events';
$txt['sp_calendar_holidays'] = 'Holidays';
$txt['sp_calendar_birthdays'] = 'Birthdays';
$txt['sp-pollViewTopic'] = 'View Topic';
$txt['sp-read_more'] = 'Read More';
$txt['sp-downloadsSize'] = 'Size';
$txt['sp-average_posts'] = 'Average Posts';
$txt['sp-average_topics'] = 'Average Topics';
$txt['sp-average_members'] = 'Average Members';
$txt['sp-average_online'] = 'Average Online';
$txt['sp-online_today'] = 'Online Today';
$txt['sp-theme_change'] = 'Change';
$txt['sp-theme_permanent'] = 'Permanently';
$txt['sp-game_plays'] = 'Plays';
$txt['sp-game_rating'] = 'Rating';
$txt['sp-games'] = 'games';
$txt['sp-champ_duration'] = 'Duration';
$txt['sp_shoutbox_title'] = 'Shoutbox';
$txt['sp_shoutbox_button'] = 'Shout!';
$txt['sp_shoutbox_no_shout'] = 'There aren\'t any shouts yet!';
$txt['sp_shoutbox_refresh'] = 'Refresh';
$txt['sp_shoutbox_history'] = 'History';
$txt['sp_shoutbox_smiley'] = 'Smileys';
$txt['sp_shoutbox_style'] = 'Styling';
$txt['sp_shoutbox_prune'] = 'Prune';
$txt['sp_shoutbox_show_ignored'] = 'show ignored shout';
$txt['sp_topstats_unknown_type'] = 'Unknown or unsupported Top Stats Type.';
$txt['sp_topstats_type_error'] = 'Incomplete Type Setup.';
$txt['sp_sashop_no_exist'] = 'Sorry, we could not find the SA Shop Mod modification';
$txt['sp_shop_no_exist'] = 'Sorry, we could not find the SMF Shop Mod modification';
$txt['sp_eliana_no_exist'] = 'Sorry, we could not find the Automatic Karma system modification, it\'s either not installed or it\'s disabled';
$txt['sp_thankomatic_no_exist'] = 'Sorry, we could not find the Thank-O-Matic modification.';
$txt['sp_reputation_no_exist'] = 'Sorry, we could not find the Advanced Reputation modification, it\'s either not installed or it\'s disabled';
$txt['sp_karma_is_disabled'] = 'Karma System is disabled';
$txt['sp_topStatsMember_total_time_logged_in'] = 'Total Time Logged In';
$txt['sp_topStatsMember_Posts'] = 'Posts';
$txt['sp_topStatsMember_Karma_Good'] = 'Good Karma';
$txt['sp_topStatsMember_Karma_Bad'] = 'Bad Karma';
$txt['sp_topStatsMember_Karma_Total'] = 'Total Karma';
$txt['sp_topStatsMember_Thank-O-Matic_Top_Given'] = 'Thank-O-Matic Given';
$txt['sp_topStatsMember_Thank-O-Matic_Top_Recived'] = 'Thank-O-Matic Recived';
$txt['sp_topStatsMember_Automatic_Karma_Good'] = 'Automatic Good Karma';
$txt['sp_topStatsMember_Automatic_Karma_Bad'] = 'Automatic Bad Karma';
$txt['sp_topStatsMember_Automatic_Karma_Total'] = 'Automatic Total Karma';
$txt['sp_topStatsMember_Advanced_Reputation_System_Best'] = 'Advanced Reputation System Best';
$txt['sp_topStatsMember_Advanced_Reputation_System_Worst'] = 'Advanced Reputation System Worst';
$txt['sp_topStatsMember_SMF_Shop_Money'] = 'SMF Shop Money';
$txt['sp_topStatsMember_SA_Shop_Cash'] = 'SA Shop Cash';
$txt['sp_topStatsMember_SA_Shop_Trades'] = 'SA Shop Trades';
$txt['sp_topStatsMember_SA_Shop_Purchase'] = 'SA Shop Purchase';
$txt['sp_topStatsMember_Casino'] = 'Casino Cash';
$txt['sp_totalTimeLogged1'] = 'Total time logged in: ';
$txt['sp_totalTimeLogged2'] = ' days, ';
$txt['sp_totalTimeLogged3'] = ' hours and ';
$txt['sp_totalTimeLogged4'] = ' minutes.';
$txt['sp_totalTimeLogged5'] = 'd ';
$txt['sp_totalTimeLogged6'] = 'h ';
$txt['sp_totalTimeLogged7'] = 'm';

// Who area strings
$txt['sp_who_index'] = 'Viewing the <a href="%s">Portal</a>.';
$txt['sp_who_forum'] = 'Viewing the <a href="%s?action=forum">Forum</a>.';
$txt['sp_who_page'] = 'Viewing the page &quot;<a href="%3$s?page=%1$s">%2$s</a>&quot;.';
$txt['sp_who_shout_history'] = 'Viewing the <a href="%s">shoutbox history</a>.';

// Error messages
$txt['error_sp_no_message_id'] = 'Invalid message ID.';
$txt['error_sp_article_exists'] = 'This article already exists.';
$txt['error_sp_cannot_add_article'] = 'You don\'t have permission to add an article.';
$txt['error_sp_cannot_remove_article'] = 'Sorry, you don\'t have permission to remove an article.';
$txt['error_sp_name_empty'] = 'The name field was left empty.';
$txt['error_sp_no_category'] = 'Sorry, articles require categories to be published! Please create a category for articles.';
$txt['error_sp_no_category_normaluser'] = 'Sorry, articles require categories to be published! Please ask an administrator to create a category for articles.';
$txt['error_sp_no_category_sp_moderator'] = 'A new category can be created <a href="%s">here</a>.';
$txt['error_sp_side_wrong'] = 'Wrong side selected.';
$txt['error_sp_block_wrong'] = 'Wrong block selected.';
$txt['error_sp_php_syntax'] = 'Syntax error in block code. Please check the code.';
$txt['error_sp_php_database'] = 'Database error in block code. Please check the code.';
$txt['error_sp_no_posts_found'] = 'No posts were found.';
$txt['error_sp_no_members_found'] = 'No members were found.';
$txt['error_sp_no_gallery_found'] = 'There are no gallery mods installed.';
$txt['error_sp_no_pictures_found'] = 'There are no pictures in the gallery.';
$txt['error_sp_no_boards_found'] = 'This forum does not have any boards.';
$txt['error_sp_no_topics_found'] = 'This forum does not have any topics.';
$txt['error_sp_no_attachments_found'] = 'No attachments were found.';
$txt['error_sp_no_polls_found'] = 'No polls were found.';
$txt['error_sp_invalid_feed'] = 'Invalid feed.';
$txt['error_sp_no_online'] = 'There aren\'t any users online.';
$txt['error_sp_no_items_day'] = '<div class="ehPortal_smallprint">No calendar events were found.</div>';
$txt['error_sp_no_blog_found'] = 'There are no blog mods installed.';
$txt['error_sp_no_blogs_found'] = 'No blogs were found.';
$txt['error_sp_no_articles_found'] = 'There are no articles to display.';
$txt['error_sp_no_shop_found'] = 'There are no shop mods installed.';
$txt['error_sp_no_arcade_found'] = 'There are no arcade mods installed.';
$txt['error_sp_no_stats_found'] = 'No statistics found.';
$txt['error_sp_page_not_found'] = 'The page you requested cannot be found.';
$txt['error_sp_shoutbox_not_exist'] = 'Sorry, this shoutbox does not exist.';
$txt['error_sp_no_shoutbox'] = 'There either aren\'t any shoutboxes created yet or there aren\'t any shoutboxes that haven\'t already been published in a shoutbox block.';
$txt['error_sp_no_shoutbox_sp_moderator'] = 'A new shoutbox can be created <a href="%s">here</a>.';
$txt['error_sp_no_shoutbox_normaluser'] = 'Sorry, shoutbox blocks require a shoutbox to be created before you can display a shoutbox using a shoutbox block ! Please ask an administrator to create a new shoutbox.';
$txt['error_sp_cannot_shoutbox_moderate'] = 'You don\'t have permission to moderate this shoutbox.';
$txt['error_sp_no_block'] = 'There aren\'t any blocks created yet.';
$txt['error_sp_flood_spsbp'] = 'Your last shout was less than %1$d seconds ago. Please try again later.';
$txt['ehcat_not_writable'] = 'The EhPortal category icon directory is not writable!';
$txt['ehcat_upload_file_size'] = 'File size is too large!';
$txt['ehcat_upload_file'] = 'Problem uploading file!';

// Shoutbox
$txt['sp_bold'] = 'Bold';
$txt['sp_italic'] = 'Italic';
$txt['sp_underline'] = 'Underline';
$txt['sp_strike'] = 'Strikethrough';
$txt['sp_preformatted'] = 'Pre';
$txt['sp_image'] = 'Insert Image';
$txt['sp_hyperlink'] = 'Insert Hyperlink';
$txt['sp_insert_email'] = 'Insert Email';
$txt['sp_glow'] = 'Glow';
$txt['sp_shadow'] = 'Shadow';
$txt['sp_superscript'] = 'Superscript';
$txt['sp_subscript'] = 'Subscript';
$txt['sp_teletype'] = 'Teletype';
$txt['sp_bbc_quote'] = 'Quote';
$txt['sp_bbc_code'] = 'Code';
$txt['sp_bbc_me'] = 'IRC Action';
$txt['sp_font_size'] = 'Font Size';
$txt['sp_font_face'] = 'Font Face';
$txt['sp_change_color'] = 'Change Color';
$txt['sp_bbc_none'] = 'No BBCode';
$txt['sp_bbc_colorize'] = 'Multicolor';
$txt['sp_bbc_input_name'] = 'Enter Name';
$txt['sp_bbc_dropdown'] = '--Select--';
$txt['sp_bbc_colors'] = 'green|red|yellow|orange|blue|purple'; /* edit the color wheel with actual css color names */
$txt['sp_bbc_color_names'] = 'Green|Red|Yellow|Orange|Blue|Purple'; /* edit for the names of the above colors */
$txt['sp_more_smileys'] = 'More Smileys';
$txt['sp_less_smileys'] = 'Less Smileys';

$txt['sp_logged_out'] = 'You have been logged out of the forum.';
$txt['sp_log_back'] = '<-- Click here to log back in -->';
$txt['sp_arcade_shout_guest_score'] = 'Guest scored %s on %s';
$txt['sp_arcade_shout_member_score'] = '%s scored %s on %s';
$txt['sp_arcade_shout_member_champ_score'] = '%s is the new champion of %s with a score of %s';
$txt['sp_arcade_shout_arena_score'] = 'From the Arena: %s scored %s on %s for round %s';

// EhPortal Profile
$txt['EhPortalSettings'] = 'EhPortal Preferences';
$txt['EhPortalSettingsDesc'] = 'EhPortal Profile Options';
$txt['EhPortalIgnoreShouts'] = 'Honor ignored users for the shoutbox';
$txt['EhPortalDisableAudio'] = 'Enable shoutbox audio';

?>